/*
 * prop_page_main_data.c  -- data for main prop page
 *
 * $Id: prop_page_main_data.c,v 1.3 2004/06/14 12:28:50 hos Exp $
 *
 */

#include <windows.h>
#include <tchar.h>
#include "main.h"

/* tree specification */
static tree_item_spec_t custom_tree_aim_sub_items[] = {
    {_T("left"), NULL, ITEM_TYPE_AXIS_LEFT, CONTROLLER_EVT_CODE_AIM_X, 0},
    {_T("right"), NULL, ITEM_TYPE_AXIS_RIGHT, CONTROLLER_EVT_CODE_AIM_X, 0},
    {_T("top"), NULL, ITEM_TYPE_AXIS_TOP, CONTROLLER_EVT_CODE_AIM_Y, 0},
    {_T("bottom"), NULL, ITEM_TYPE_AXIS_BTM, CONTROLLER_EVT_CODE_AIM_Y, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_right_items[] = {
    {_T("AIMING LEVER"), custom_tree_aim_sub_items, ITEM_TYPE_AXIS_HV,
     CONTROLLER_EVT_CODE_AIM_X, CONTROLLER_EVT_CODE_AIM_Y},
    {_T("MAIN WEAPON"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MAIN_WEAPON, 0},
    {_T("SUB WEAPON"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_SUB_WEAPON, 0},
    {_T("LOCK ON"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_LOCK_ON, 0},
    {_T("EJECT CMD"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_EJECT_CMD, 0},
    {_T("COCPIT HATCH"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_COCPIT_HATCH, 0},
    {_T("IGNITION"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_IGNITION, 0},
    {_T("START"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_START, 0},
    {_T("MULTI MONITOR - OPEN/CLOSE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MLM_OPEN_CLOSE, 0},
    {_T("MULTI MONITOR - MAP ZOOM IN/OUT"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MLM_MAP_ZOOM, 0},
    {_T("MULTI MONITOR - MODE SELECT"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MLM_MODE_SELECT, 0},
    {_T("SUB MONITOR MODE SELECT"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_SM_MODE_SELECT, 0},
    {_T("MAIN MONITOR - ZOOM IN"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MM_ZOOM_IN, 0},
    {_T("MAIN MONITOR - ZOOM OUT"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MM_ZOOM_OUT, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_tuner_sub_items[] = {
    {_T("1 (left)"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_TUNER_E, 0},
    {_T("2"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_ENE, 0},
    {_T("3"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_NE, 0},
    {_T("4"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_NNE, 0},
    {_T("5 (top)"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_TUNER_N, 0},
    {_T("6"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_NNW, 0},
    {_T("7"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_NW, 0},
    {_T("8"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_WNW, 0},
    {_T("9 (right)"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_TUNER_W, 0},
    {_T("10"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_WSW, 0},
    {_T("11"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_SW, 0},
    {_T("12"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_SSW, 0},
    {_T("13 (bottom)"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_TUNER_S, 0},
    {_T("14"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_SSE, 0},
    {_T("15"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_SE, 0},
    {_T("16"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_TUNER_ESE, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_center_items[] = {
    {_T("F.S.S"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_FSS, 0},
    {_T("MANIPULATOR"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_MANIPULATOR, 0},
    {_T("LINE COLOR CHANGE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_LINE_COLOR_CHANGE, 0},
    {_T("TANK DETACH"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_TANK_DETACH, 0},
    {_T("OVERRIDE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_OVERRIDE, 0},
    {_T("NIGHT SCOPE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_NIGHT_SCOPE, 0},
    {_T("F1"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_F1, 0},
    {_T("F2"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_F2, 0},
    {_T("F3"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_F3, 0},

    {_T("WASHING"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_WASHING, 0},
    {_T("EXTINGUISHER"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_EXTINGUISHER, 0},
    {_T("CHAFF"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CHAFF, 0},
    {_T("WEAPON CONTROLS - MAIN"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_WC_MAIN, 0},
    {_T("WEAPON CONTROLS - SUB"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_WC_SUB, 0},
    {_T("WEAPON CONTROLS - MAGAZINE CHANGE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_WC_MAGAZINE_CHANGE, 0},

    {_T("COMMUNICATION BUTTON 1"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CT_1, 0},
    {_T("COMMUNICATION BUTTON 2"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CT_2, 0},
    {_T("COMMUNICATION BUTTON 3"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CT_3, 0},
    {_T("COMMUNICATION BUTTON 4"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CT_4, 0},
    {_T("COMMUNICATION BUTTON 5"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_CT_5, 0},
    {_T("TUNER DIAL"), custom_tree_tuner_sub_items, 0, 0, TVIS_EXPANDED},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_rotation_sub_items[] = {
    {_T("left"), NULL, ITEM_TYPE_AXIS_LEFT, CONTROLLER_EVT_CODE_ROTATION, 0},
    {_T("right"), NULL, ITEM_TYPE_AXIS_RIGHT, CONTROLLER_EVT_CODE_ROTATION, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_sight_sub_items[] = {
    {_T("left"), NULL, ITEM_TYPE_AXIS_LEFT, CONTROLLER_EVT_CODE_SIGHT_X, 0},
    {_T("right"), NULL, ITEM_TYPE_AXIS_RIGHT, CONTROLLER_EVT_CODE_SIGHT_X, 0},
    {_T("top"), NULL, ITEM_TYPE_AXIS_TOP, CONTROLLER_EVT_CODE_SIGHT_Y, 0},
    {_T("bottom"), NULL, ITEM_TYPE_AXIS_BTM, CONTROLLER_EVT_CODE_SIGHT_Y, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_gear_sub_items[] = {
    {_T("R"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_R, 0},
    {_T("N"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_N, 0},
    {_T("1"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_1, 0},
    {_T("2"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_2, 0},
    {_T("3"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_3, 0},
    {_T("4"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_4, 0},
    {_T("5"), NULL, ITEM_TYPE_BTN_DIGITAL, CONTROLLER_EVT_CODE_GEAR_5, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_left_items[] = {
    {_T("ROTATION LEVER"), custom_tree_rotation_sub_items, ITEM_TYPE_AXIS_H,
     CONTROLLER_EVT_CODE_ROTATION, 0},
    {_T("SIGHT CHANGE"), custom_tree_sight_sub_items, ITEM_TYPE_AXIS_HV,
     CONTROLLER_EVT_CODE_SIGHT_X, CONTROLLER_EVT_CODE_SIGHT_Y},
    {_T("GEAR LEVER"), custom_tree_gear_sub_items, 0, 0, TVIS_EXPANDED},

    {_T("SIGHT CHANGE BUTTON"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_SIGHT_BUTTON, 0},

    {_T("OXYGEN SUPPLY SYSTEM"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_OXYGEN_SUPPLY_SYSTEM, 0},
    {_T("FILT CONTROL SYSTEM"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_FILT_CONTROL_SYSTEM, 0},
    {_T("VT-LOCATION MEASUREMENT"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_VT_LOCATION_MEASUREMENT, 0},
    {_T("BUFFER MATERIAL"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_BUFFER_MATERIAL, 0},
    {_T("FUEL FLOW RATE"), NULL, ITEM_TYPE_BTN_DIGITAL,
     CONTROLLER_EVT_CODE_FUEL_FLOW_RATE, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_foot_left_items[] = {
    {_T("motion"), NULL, ITEM_TYPE_BTN_ANALOG_MOTION,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_LEFT, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_foot_center_items[] = {
    {_T("motion"), NULL, ITEM_TYPE_BTN_ANALOG_MOTION,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_CENTER, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_foot_right_items[] = {
    {_T("motion"), NULL, ITEM_TYPE_BTN_ANALOG_MOTION,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_RIGHT, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_foot_items[] = {
    {_T("LEFT"), custom_tree_foot_left_items, ITEM_TYPE_BTN_ANALOG,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_LEFT, 0},
    {_T("CENTER"), custom_tree_foot_center_items, ITEM_TYPE_BTN_ANALOG,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_CENTER, 0},
    {_T("RIGHT"), custom_tree_foot_right_items, ITEM_TYPE_BTN_ANALOG,
     CONTROLLER_EVT_CODE_FOOT_PEDAL_RIGHT, 0},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_controller_items[] = {
    {_T("RIGHT BLOCK"), custom_tree_right_items, 0, 0, 0, TVIS_EXPANDED},
    {_T("CENTER BLOCK"), custom_tree_center_items, 0, 0, 0, TVIS_EXPANDED},
    {_T("LEFT BLOCK"), custom_tree_left_items, 0, 0, 0, TVIS_EXPANDED},
    {_T("FOOT PEDAL"), custom_tree_foot_items, 0, 0, 0, TVIS_EXPANDED},

    {NULL, NULL, 0, 0, 0}
};

static tree_item_spec_t custom_tree_items[] = {
    /* controller setting */
    {_T("controller"), custom_tree_controller_items,
     ITEM_TYPE_CONTRLLER_ROOT, 0, 0, TVIS_EXPANDED},
    {_T("action list"), NULL, ITEM_TYPE_ACTION_ROOT, 0, 0, TVIS_EXPANDED},

    {NULL, NULL, 0, 0, 0}
};

tree_item_spec_t custom_tree_root = {
    /* root */
    TEXT("customize"), custom_tree_items, ITEM_TYPE_ROOT, 0, 0, TVIS_EXPANDED
};
